searchNodes=[{"ref":"Kale.html","title":"Kale","type":"module","doc":"An ExUnit test case for writing features using Kale. Usage defmodule MyTest do use ExUnit.Case, async: true use Kale feature &quot;Feature description here&quot; do scenario &quot;Scenario description here&quot;, &quot;&quot;&quot; Given some precondition When action {foo} happens Then the result is {bar} &quot;&quot;&quot; end defgiven &quot;some precondition&quot; do # ... end defwhen &quot;action {action} happens&quot; do # interpolated variables are magically available result = do_something(action) # if the step returns a map, it will be merged with the test context %{result: result} end defthen &quot;the result is {expected}&quot;, %{result: result} do # Optional second argument for context, as per standard ExUnit assert result == expected end end Each feature generates a describe, and each scenario a test. Standard ExUnit features such as setup can be used as normal. To avoid the formatter inserting extra parens, you can specify import_deps: [:kale] in your .formatter.exs."},{"ref":"Kale.Macros.html","title":"Kale.Macros","type":"module","doc":"Macros, automatically imported by use Kale."},{"ref":"Kale.Macros.html#defgiven/3","title":"Kale.Macros.defgiven/3","type":"macro","doc":"Generate a step definition matching a particular string and optionally a context map. See the module documentation for usage examples. The given, when and then steps are actually interchangeable &ndash; the separate macros are provided for readability only."},{"ref":"Kale.Macros.html#defthen/3","title":"Kale.Macros.defthen/3","type":"macro","doc":"An alias for defgiven/2."},{"ref":"Kale.Macros.html#defwhen/3","title":"Kale.Macros.defwhen/3","type":"macro","doc":"An alias for defgiven/2."},{"ref":"Kale.Macros.html#feature/2","title":"Kale.Macros.feature/2","type":"macro","doc":"Generate a feature block, which corresponds to an ExUnit describe."},{"ref":"Kale.Macros.html#scenario/2","title":"Kale.Macros.scenario/2","type":"macro","doc":"Generate a scenario block, which corresponds to an ExUnit test."},{"ref":"Kale.Utils.html","title":"Kale.Utils","type":"module","doc":"Utility functions, used by macros and the functions they create."},{"ref":"Kale.Utils.html#extract_args/1","title":"Kale.Utils.extract_args/1","type":"function","doc":"Return the interpolated variables or argument names from a string. Elements in the returned list will always be strings. iex&gt; Kale.Utils.extract_args(&quot;When I add {a} and{b}&quot;) [&quot;a&quot;, &quot;b&quot;] iex&gt; Kale.Utils.extract_args(&quot;When I add {1} and{2}&quot;) [&quot;1&quot;, &quot;2&quot;]"},{"ref":"Kale.Utils.html#normalise_name/1","title":"Kale.Utils.normalise_name/1","type":"function","doc":"Remove interpolated variables from a step string, so that the call matches the definition. iex&gt; Kale.Utils.normalise_name(&quot;I log on as {username}&quot;) &quot;I log on as {}&quot; iex&gt; Kale.Utils.normalise_name(&quot;I log on as {fred}&quot;) &quot;I log on as {}&quot;"},{"ref":"readme.html","title":"Kale","type":"extras","doc":"Kale Basic given-when-then steps for ExUnit tests."},{"ref":"readme.html#why","title":"Kale - Why?","type":"extras","doc":"I have previously used White Bread and Cabbage for writing Cucumber-style (Gherkin) tests, but decided I didn&#39;t really need the extra complexity over simple ExUnit tests. However, I quite like writing acceptance tests in a &quot;given, when, then&quot; format &ndash; I find it makes the described functionality easier to read, even if you aren&#39;t going the full BDD route and writing the scenarios with your customers. This library is an experiment to try to come up with a minimal layer on top of ExUnit to allow this. It was also an excuse to delve into the world of Elixir metaprogramming. Kale does not implement the full gherkin language. Instead it uses simple string matching (no regexes) with the ability to explicitly interpolate values by surrounding them with {}. Why &quot;Kale&quot;? As a nod to Spinach."},{"ref":"readme.html#installation","title":"Kale - Installation","type":"extras","doc":"Kale is available in Hex, and can be installed by adding it to your list of dependencies in mix.exs: def deps do [ {:kale, &quot;~&gt; 0.7.0&quot;, only: :test} ] end Then run mix deps.get. If you want to use Kale&#39;s formatter rules (to avoid having parens inserted around the arguments of scenario, defwhen etc), import it in your .formatter.exs: [ # ... import_deps: [:kale] ]"},{"ref":"readme.html#usage","title":"Kale - Usage","type":"extras","doc":"In your test, use Kale: defmodule MyTest do use ExUnit.Case, async: true use Kale # ... end Then write a feature (which corresponds to an ExUnit describe) containing one or more scenarios: feature &quot;Feature description here&quot; do scenario &quot;Scenario description here&quot;, &quot;&quot;&quot; Given some precondition When action {foo} happens Then the result is {bar} &quot;&quot;&quot; scenario &quot;Another scenario&quot;, &quot;&quot;&quot; ... &quot;&quot;&quot; end Each scenario has a description, and a multiline string containing a list of steps, which should all begin with one of Given, When, Then, And, But or *. Lines beginning with anything else are treated as comments and ignored. Each unique step needs a definition, which needs to be created in the test module by calling defgiven, defwhen or defthen. Technically it doesn&#39;t matter which of the three you use, but it&#39;s recommended to use the one that matches the step for redability. The simplest form of step definition just takes a literal string argument matching the step from the scenario, and a block of code to execute: defgiven &quot;some precondition&quot; do # ... end If you need to access the ExUnit context, it can be provided as a second argument: defgiven &quot;some precondition&quot;, context do login(context.user) end You can also pattern match specific values from the context: defgiven &quot;some precondition&quot;, %{user: user} do login(user) end If a step definition returns a map, a keyword list, or an {:ok, context} tuple (where context is a map or a keyword list), it will be merged into the context for future steps in the same scenario. For example, to store a value for session: defgiven &quot;some precondition&quot;, %{user: user} do session = login(context.user) %{session: session} end Values can be interpolated by wrapping them in {}. The value from the step in the scanario will be available within the body of the step definition using the variable name provided: defwhen &quot;action {action} happens&quot; do do_something(action) end Tests are run just like normal ExUnit tests (which is what they compile to). This includes being able to specify the line number of the scenario or feature. Tests are reported as &quot;features&quot; by ExUnit, separately from other tests: $ mix test ................ Finished in 0.08 seconds 6 features, 10 tests, 0 failures Randomized with seed 955579"},{"ref":"readme.html#development","title":"Kale - Development","type":"extras","doc":"To build the project after cloning: $ mix deps.get $ make ## TODO * More helpful errors when no step matches"},{"ref":"license.html","title":"LICENSE","type":"extras","doc":"MIT License Copyright (c) 2019 Kerry Buckley Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog, and this project adheres to Semantic Versioning."},{"ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras","doc":""},{"ref":"changelog.html#0-7-0-2019-06-12","title":"Changelog - 0.7.0 - 2019-06-12","type":"extras","doc":"Changed Remove FeatureCase. Clients should use Kale as well as the normal ExUnit.Case etc."},{"ref":"changelog.html#0-6-2-2019-06-10","title":"Changelog - 0.6.2 - 2019-06-10","type":"extras","doc":"Changed Fix hex link in README"},{"ref":"changelog.html#0-6-1-2019-06-10","title":"Changelog - 0.6.1 - 2019-06-10","type":"extras","doc":"Changed Fix some typos in the README"},{"ref":"changelog.html#0-6-0-2019-06-10","title":"Changelog - 0.6.0 - 2019-06-10","type":"extras","doc":"Added Report tests as &quot;features&quot; when running mix test Allow keyword lists and :ok tuples for returning context (not just maps) Set minimum Elixir version to 1.3 (when describe was added to ExUnit) Link to source code from docs Add licence to docs Add this changelog"},{"ref":"changelog.html#0-5-1-2019-06-07","title":"Changelog - 0.5.1 - 2019-06-07","type":"extras","doc":"Added Improved documentation More checks, and a makefile"},{"ref":"changelog.html#0-5-0-2019-06-06","title":"Changelog - 0.5.0 - 2019-06-06","type":"extras","doc":"Changed Automatically make interpolated variables available in steps Make context argument optional"},{"ref":"changelog.html#0-4-0-2019-06-05","title":"Changelog - 0.4.0 - 2019-06-05","type":"extras","doc":"Changed Specify steps as multiline strings Pass context between steps"},{"ref":"changelog.html#0-3-0-2019-06-04","title":"Changelog - 0.3.0 - 2019-06-04","type":"extras","doc":"Changed Make args and context explicit arguments of defwhen etc"},{"ref":"changelog.html#0-2-0-2019-05-27","title":"Changelog - 0.2.0 - 2019-05-27","type":"extras","doc":"Changed Move FeatureCase into Kale namespace"},{"ref":"changelog.html#0-1-1-2019-05-27","title":"Changelog - 0.1.1 - 2019-05-27","type":"extras","doc":"Added Include README in generated docs"},{"ref":"changelog.html#0-1-0-2019-05-27","title":"Changelog - 0.1.0 - 2019-05-27","type":"extras","doc":"Added Initial release"}]